Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.swt.widgets
Class ScrollBar

    java.lang.Object
      org.eclipse.swt.widgets.Widget
          org.eclipse.swt.widgets.ScrollBar

public class ScrollBar
extends Widget

Instances of this class are selectable user interface objects that represent a range of positive, numeric values.

At any given moment, a given scroll bar will have a single selection that is considered to be its value, which is constrained to be within the range of values the scroll bar represents (that is, between its minimum and maximum values).

Typically, scroll bars will be made up of five areas:

1. an arrow button for decrementing the value
2. a page decrement area for decrementing the value by a larger amount
3. a thumb for modifying the value by mouse dragging
4. a page increment area for incrementing the value by a larger amount
5. an arrow button for incrementing the value

Based on their style, scroll bars are either `HORIZONTAL` (which have a left facing button for decrementing the value and a right facing button for incrementing it) or `VERTICAL` (which have an upward facing button for decrementing the value and a downward facing buttons for incrementing it).

On some platforms, the size of the scroll bar's thumb can be varied relative to the magnitude of the range of values it represents (that is, relative to the difference between its maximum and minimum values). Typically, this is used to indicate some proportional value such as the ratio of the visible area of a document to the total amount of space that it would take to display it. SWT supports setting the thumb size even if the underlying platform does not, but in this case the appearance of the scroll bar will not change.

Scroll bars are created by specifying either `H_SCROLL`, `V_SCROLL` or both when creating a `Scrollable`. They are accessed from the `Scrollable` using `getHorizontalBar` and `getVerticalBar`.

Note: Scroll bars are not Controls. On some platforms, scroll bars that appear as part of some standard controls such as a text or list have no operating system resources and are not children of the control. For this reason, scroll bars are treated specially. To create a control that looks like a scroll bar but has operating system resources, use `Slider`.

Styles:
  HORIZONTAL, VERTICAL
Events:
  Selection

Note: Only one of the styles HORIZONTAL and VERTICAL may be specified.

IMPORTANT: This class is not intended to be subclassed.

See Also:
  `Slider`, `Scrollable`, `Scrollable.getHorizontalBar()`, `Scrollable.getVerticalBar()`

Method Summary
`void` | `addSelectionListener(SelectionListener listener)` Adds the listener to the collection of listeners who will be notified when the receiver's value changes, by sending it one of the messages defined in the `SelectionListener` interface.
`void` | `dispose()` Disposes of the operating system resources associated with the receiver and all its descendents.
`boolean` | `getEnabled()` Returns `true` if the receiver is enabled, and `false` otherwise.
`int` | `getIncrement()` Returns the amount that the receiver's value will be modified by when the up/down (or right/left) arrows are pressed.
`int` | `getMaximum()` Returns the maximum value which the receiver will allow.
`int` | `getMinimum()` Returns the minimum value which the receiver will allow.
`int` | `getPageIncrement()` Returns the amount that the receiver's value will be modified by when the page increment/decrement areas are selected.
`Scrollable` | `getParent()` Returns the receiver's parent, which must be scrollable.
`int` | `getSelection()` Returns the single selection that is the receiver's value.
`Point` | `getSize()` Returns a point describing the receiver's size.
`int` | `getThumb()` Answers the size of the receiver's thumb relative to the difference between its maximum and minimum values.
`boolean` | `getVisible()` Returns `true` if the receiver is visible, and `false` otherwise.
`boolean` | `isEnabled()` Returns `true` if the receiver is enabled and all of the receiver's ancestors are enabled, and `false` otherwise.
`boolean` | `isVisible()` Returns `true` if the receiver is visible and all of the receiver's ancestors are visible and `false` otherwise.
`void` | `removeSelectionListener(SelectionListener listener)` Removes the listener from the collection of listeners who will be notified when the receiver's value changes.
`void` | `setEnabled(boolean enabled)` Enables the receiver if the argument is `true`, and disables it otherwise.
`void` | `setIncrement(int value)` Sets the amount that the receiver's value will be modified by when the up/down (or right/left) arrows are pressed to the argument, which must be at least one.
`void` | `setMaximum(int value)` Sets the maximum.
`void` | `setMinimum(int value)` Sets the minimum value.
`void` | `setPageIncrement(int value)` Sets the amount that the receiver's value will be modified by when the page increment/decrement areas are selected to the argument, which must be at least one.
`void` | `setSelection(int selection)` Sets the single selection that is the receiver's value to the argument which must be greater than or equal to zero.
`void` | `setThumb(int value)` Sets the size of the receiver's thumb relative to the difference between its maximum and minimum values.
`void` | `setValues(int selection, int minimum, int maximum, int thumb, int increment, int pageIncrement)` Sets the receiver's selection, minimum value, maximum value, thumb, increment and page increment all at once.
`void` | `setVisible(boolean visible)` Marks the receiver as visible if the argument is `true`, and marks it invisible otherwise.

Methods inherited from class org.eclipse.swt.widgets.Widget
`addDisposeListener, addListener, checkSubclass, checkWidget, getData, getData, getDisplay, getStyle, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, setData, setData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### addSelectionListener

    public void addSelectionListener(SelectionListener listener)

  Adds the listener to the collection of listeners who will be notified when the receiver's value changes, by sending it one of the messages defined in the `SelectionListener` interface.

  When `widgetSelected` is called, the event object detail field contains one of the following values: `0` - for the end of a drag. `SWT.DRAG`. `SWT.HOME`. `SWT.END`. `SWT.ARROW_DOWN`. `SWT.ARROW_UP`. `SWT.PAGE_DOWN`. `SWT.PAGE_UP`. `widgetDefaultSelected` is not called.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `SelectionListener`, `removeSelectionListener(org.eclipse.swt.events.SelectionListener)`, `SelectionEvent`

### dispose

    public void dispose()

  Description copied from class: `Widget`
  Disposes of the operating system resources associated with the receiver and all its descendents. After this method has been invoked, the receiver and all descendents will answer `true` when sent the message `isDisposed()`. Any internal connections between the widgets in the tree will have been removed to facilitate garbage collection.

  NOTE: This method is not called recursively on the descendents of the receiver. This means that, widget implementers can not detect when a widget is being disposed of by re-implementing this method, but should instead listen for the `Dispose` event.

  Overrides:
    `dispose` in class `Widget`
  See Also:
    `Widget.addDisposeListener(org.eclipse.swt.events.DisposeListener)`, `Widget.removeDisposeListener(org.eclipse.swt.events.DisposeListener)`, `Widget.checkWidget()`

### getEnabled

    public boolean getEnabled()

  Returns `true` if the receiver is enabled, and `false` otherwise. A disabled control is typically not selectable from the user interface and draws with an inactive or "grayed" look.

  Returns:
    the receiver's enabled state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `isEnabled()`

### getIncrement

    public int getIncrement()

  Returns the amount that the receiver's value will be modified by when the up/down (or right/left) arrows are pressed.

  Returns:
    the increment
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getMaximum

    public int getMaximum()

  Returns the maximum value which the receiver will allow.

  Returns:
    the maximum
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getMinimum

    public int getMinimum()

  Returns the minimum value which the receiver will allow.

  Returns:
    the minimum
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getPageIncrement

    public int getPageIncrement()

  Returns the amount that the receiver's value will be modified by when the page increment/decrement areas are selected.

  Returns:
    the page increment
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getParent

    public Scrollable getParent()

  Returns the receiver's parent, which must be scrollable.

  Returns:
    the receiver's parent
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getSelection

    public int getSelection()

  Returns the single selection that is the receiver's value.

  Returns:
    the selection
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getSize

    public Point getSize()

  Returns a point describing the receiver's size. The x coordinate of the result is the width of the receiver. The y coordinate of the result is the height of the receiver.

  Returns:
    the receiver's size
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getThumb

    public int getThumb()

  Answers the size of the receiver's thumb relative to the difference between its maximum and minimum values.

  Returns:
    the thumb value
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `ScrollBar`

### getVisible

    public boolean getVisible()

  Returns `true` if the receiver is visible, and `false` otherwise.

  If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, this method may still indicate that it is considered visible even though it may not actually be showing.

  Returns:
    the receiver's visibility state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### isEnabled

    public boolean isEnabled()

  Returns `true` if the receiver is enabled and all of the receiver's ancestors are enabled, and `false` otherwise. A disabled control is typically not selectable from the user interface and draws with an inactive or "grayed" look.

  Returns:
    the receiver's enabled state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `getEnabled()`

### isVisible

    public boolean isVisible()

  Returns `true` if the receiver is visible and all of the receiver's ancestors are visible and `false` otherwise.

  Returns:
    the receiver's visibility state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `getVisible()`

### removeSelectionListener

    public void removeSelectionListener(SelectionListener listener)

  Removes the listener from the collection of listeners who will be notified when the receiver's value changes.

  Parameters:
    `listener` - the listener which should no longer be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `SelectionListener`, `addSelectionListener(org.eclipse.swt.events.SelectionListener)`

### setEnabled

    public void setEnabled(boolean enabled)

  Enables the receiver if the argument is `true`, and disables it otherwise. A disabled control is typically not selectable from the user interface and draws with an inactive or "grayed" look.

  Parameters:
    `enabled` - the new enabled state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setIncrement

    public void setIncrement(int value)

  Sets the amount that the receiver's value will be modified by when the up/down (or right/left) arrows are pressed to the argument, which must be at least one.

  Parameters:
    `value` - the new increment (must be greater than zero)
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setMaximum

    public void setMaximum(int value)

  Sets the maximum. If this value is negative or less than or equal to the minimum, the value is ignored. If necessary, first the thumb and then the selection are adjusted to fit within the new range.

  Parameters:
    `value` - the new maximum
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setMinimum

    public void setMinimum(int value)

  Sets the minimum value. If this value is negative or greater than or equal to the maximum, the value is ignored. If necessary, first the thumb and then the selection are adjusted to fit within the new range.

  Parameters:
    `value` - the new minimum
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setPageIncrement

    public void setPageIncrement(int value)

  Sets the amount that the receiver's value will be modified by when the page increment/decrement areas are selected to the argument, which must be at least one.

  Parameters:
    `value` - the page increment (must be greater than zero)
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setSelection

    public void setSelection(int selection)

  Sets the single selection that is the receiver's value to the argument which must be greater than or equal to zero.

  Parameters:
    `selection` - the new selection (must be zero or greater)
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setThumb

    public void setThumb(int value)

  Sets the size of the receiver's thumb relative to the difference between its maximum and minimum values. This new value will be ignored if it is less than one, and will be clamped if it exceeds the receiver's current range.

  Parameters:
    `value` - the new thumb value, which must be at least one and not larger than the size of the current range
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setValues

    public void setValues(int selection,
                          int minimum,
                          int maximum,
                          int thumb,
                          int increment,
                          int pageIncrement)

  Sets the receiver's selection, minimum value, maximum value, thumb, increment and page increment all at once.

  Note: This is equivalent to setting the values individually using the appropriate methods, but may be implemented in a more efficient fashion on some platforms.

  Parameters:
    `selection` - the new selection value
    `minimum` - the new minimum value
    `maximum` - the new maximum value
    `thumb` - the new thumb value
    `increment` - the new increment value
    `pageIncrement` - the new pageIncrement value
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setVisible

    public void setVisible(boolean visible)

  Marks the receiver as visible if the argument is `true`, and marks it invisible otherwise.

  If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, marking it visible may not actually cause it to be displayed.

  Parameters:
    `visible` - the new visibility state
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse Platform Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Guidelines for using Eclipse APIs.

Copyright (c) IBM Corp. and others 2000, 2004. All rights reserved.